import SqlQuery from '../Queries/SqlQuery';
import DatabaseInterface from './DatabaseInterface';
import { Pool, PoolConnection, PoolConfig } from 'mysql';
export default class MySqlDatabase implements DatabaseInterface {
    readonly connection: Pool | PoolConnection;
    constructor(connection: PoolConfig | Pool | PoolConnection);
    disconnect(): Promise<void>;
    indexToPlaceholder(i: number): string;
    query(query: SqlQuery): Promise<any[]>;
    sequence<T>(sequence: (sequenceDb: MySqlDatabase) => Promise<T>): Promise<T>;
    migrate(migrations: {
        [key: string]: SqlQuery;
    }): Promise<void>;
    insertAndGet(standardInsertQuery: SqlQuery): Promise<number[] | string[] | any[]>;
    updateAndGet(standardUpdateQuery: SqlQuery): Promise<null | any[]>;
}
