"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var migrate_1 = require("./Common/migrate");
var mysql_1 = require("mysql");
// Note: The mysql package does not expose the classes, so we have to rely on those ugly tests instead.
var isPoolOrPoolConnection = function (connection) {
    // Note: The mysql pacakge does not expose the classes, so we cannot use a proper instanceof...
    return connection.query && connection.query instanceof Function;
};
var isPool = function (connection) {
    return isPoolOrPoolConnection(connection)
        && connection.end
        && !(connection.release);
};
var MySqlDatabase = /** @class */ (function () {
    function MySqlDatabase(connection) {
        if (isPoolOrPoolConnection(connection)) {
            this.connection = connection;
        }
        else {
            this.connection = mysql_1.createPool(connection);
        }
    }
    MySqlDatabase.prototype.disconnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (isPool(this.connection)) {
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            _this.connection.end(function (err) {
                                if (err) {
                                    reject(err);
                                }
                                else {
                                    resolve();
                                }
                            });
                        })];
                }
                return [2 /*return*/];
            });
        });
    };
    MySqlDatabase.prototype.indexToPlaceholder = function (i) {
        return '?';
    };
    MySqlDatabase.prototype.query = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var compiledQuery = query.compile(_this.indexToPlaceholder, mysql_1.escapeId);
                        _this.connection.query(compiledQuery.sql, compiledQuery.params, function (error, rows) {
                            if (error) {
                                reject(error);
                            }
                            else {
                                resolve(rows);
                            }
                        });
                    })];
            });
        });
    };
    MySqlDatabase.prototype.sequence = function (sequence) {
        return __awaiter(this, void 0, void 0, function () {
            var client, result, error_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!isPool(this.connection)) {
                            // Already in a sequence, so another call changes nothing but works for conveniency
                            return [2 /*return*/, sequence(this)];
                        }
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                _this.connection.getConnection(function (error, connection) {
                                    if (error) {
                                        reject(error);
                                    }
                                    else {
                                        _this.connection.acquireConnection(connection, function (error, connection) {
                                            if (error) {
                                                reject(error);
                                            }
                                            else {
                                                resolve(connection);
                                            }
                                        });
                                    }
                                });
                            })];
                    case 1:
                        client = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, sequence(new MySqlDatabase(client))];
                    case 3:
                        result = _a.sent();
                        client.release();
                        return [2 /*return*/, result];
                    case 4:
                        error_1 = _a.sent();
                        client.release();
                        throw error_1;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    MySqlDatabase.prototype.migrate = function (migrations) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, migrate_1.default(this, migrations)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MySqlDatabase.prototype.insertAndGet = function (standardInsertQuery) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var compiledQuery = standardInsertQuery.compile(_this.indexToPlaceholder, mysql_1.escapeId);
                        _this.connection.query(compiledQuery.sql, compiledQuery.params, function (error, _a) {
                            var insertId = _a.insertId;
                            if (error) {
                                reject(error);
                            }
                            else {
                                resolve([insertId]);
                            }
                        });
                    })];
            });
        });
    };
    MySqlDatabase.prototype.updateAndGet = function (standardUpdateQuery) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.query(standardUpdateQuery)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, null];
                }
            });
        });
    };
    return MySqlDatabase;
}());
exports.default = MySqlDatabase;
