import { Pool, ClientBase, PoolConfig } from 'pg';
import SqlQuery from '../Queries/SqlQuery';
import DatabaseInterface from './DatabaseInterface';
export default class PgSqlDatabase implements DatabaseInterface {
    readonly connection: Pool | ClientBase;
    constructor(connection: PoolConfig | Pool | ClientBase);
    disconnect(): Promise<void>;
    indexToPlaceholder(i: number): string;
    query(query: SqlQuery): Promise<any[]>;
    sequence<T>(sequence: (sequenceDb: PgSqlDatabase) => Promise<T>): Promise<T>;
    migrate(migrations: {
        [key: string]: SqlQuery;
    }): Promise<void>;
    insertAndGet(standardInsertQuery: SqlQuery): Promise<number[] | string[] | any[]>;
    updateAndGet(standardUpdateQuery: SqlQuery): Promise<null | any[]>;
}
