"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pg_1 = require("pg");
var pg_format_1 = require("pg-format");
var SqlQuery_1 = require("../Queries/SqlQuery");
var migrate_1 = require("./Common/migrate");
var sql = SqlQuery_1.default.createFromTemplateString;
var PgSqlDatabase = /** @class */ (function () {
    function PgSqlDatabase(connection) {
        if (connection instanceof pg_1.Pool || connection instanceof pg_1.Client) {
            this.connection = connection;
        }
        else {
            this.connection = new pg_1.Pool(connection);
        }
    }
    PgSqlDatabase.prototype.disconnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.connection instanceof pg_1.Pool)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.connection.end()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    PgSqlDatabase.prototype.indexToPlaceholder = function (i) {
        return '$' + (i + 1);
    };
    PgSqlDatabase.prototype.query = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var compiledQuery, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        compiledQuery = query.compile(this.indexToPlaceholder, pg_format_1.ident);
                        return [4 /*yield*/, this.connection.query(compiledQuery.sql, compiledQuery.params)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.rows];
                }
            });
        });
    };
    PgSqlDatabase.prototype.sequence = function (sequence) {
        return __awaiter(this, void 0, void 0, function () {
            var client, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.connection instanceof pg_1.Pool)) {
                            // Already in a sequence, so another call changes nothing but works for conveniency
                            return [2 /*return*/, sequence(this)];
                        }
                        return [4 /*yield*/, this.connection.connect()];
                    case 1:
                        client = (_a.sent());
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, sequence(new PgSqlDatabase(client))];
                    case 3:
                        result = _a.sent();
                        client.release();
                        return [2 /*return*/, result];
                    case 4:
                        error_1 = _a.sent();
                        client.release();
                        throw error_1;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    PgSqlDatabase.prototype.migrate = function (migrations) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, migrate_1.default(this, migrations)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PgSqlDatabase.prototype.insertAndGet = function (standardInsertQuery) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.query(sql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\t", "\n\t\t\tRETURNING *;\n\t\t"], ["\n\t\t\t", "\n\t\t\tRETURNING *;\n\t\t"])), standardInsertQuery))];
            });
        });
    };
    PgSqlDatabase.prototype.updateAndGet = function (standardUpdateQuery) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.query(sql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t\t\t", "\n\t\t\tRETURNING *;\n\t\t"], ["\n\t\t\t", "\n\t\t\tRETURNING *;\n\t\t"])), standardUpdateQuery))];
            });
        });
    };
    return PgSqlDatabase;
}());
exports.default = PgSqlDatabase;
var templateObject_1, templateObject_2;
