import { Database } from 'sqlite3';
import SqlQuery from '../Queries/SqlQuery';
import DatabaseInterface from './DatabaseInterface';
declare type SqliteConfig = {
    filename: string;
    mode?: number;
};
export default class SqliteDatabase implements DatabaseInterface {
    readonly connection: Database;
    constructor(connection: SqliteConfig | Database);
    disconnect(): Promise<void>;
    indexToPlaceholder(i: number): string;
    query(query: SqlQuery): Promise<any[]>;
    sequence<T>(sequence: (sequenceDb: SqliteDatabase) => Promise<T>): Promise<T>;
    migrate(migrations: {
        [key: string]: SqlQuery;
    }): Promise<void>;
    insertAndGet(standardInsertQuery: SqlQuery): Promise<number[] | string[] | any[]>;
    updateAndGet(standardUpdateQuery: SqlQuery): Promise<null | any[]>;
}
export {};
